# ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server

OryHydraCloudNativeOAuth20AndOpenIdConnectServer - JavaScript client for ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server
Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here. Keep in mind that this document reflects the latest branch, always. Support for versioned documentation is coming in the future.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: Latest
- Package version: Latest
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen
For more information, please visit [https://www.ory.sh](https://www.ory.sh)

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var OryHydraCloudNativeOAuth20AndOpenIdConnectServer = require('ory_hydra___cloud_native_o_auth_20_and_open_id_connect_server');

var api = new OryHydraCloudNativeOAuth20AndOpenIdConnectServer.HealthApi()

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.isInstanceAlive(callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.HealthApi* | [**isInstanceAlive**](docs/HealthApi.md#isInstanceAlive) | **GET** /health/alive | Check the Alive Status
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.HealthApi* | [**isInstanceReady**](docs/HealthApi.md#isInstanceReady) | **GET** /health/ready | Check the Readiness Status
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**createJsonWebKeySet**](docs/JsonWebKeyApi.md#createJsonWebKeySet) | **POST** /keys/{set} | Generate a new JSON Web Key
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**deleteJsonWebKey**](docs/JsonWebKeyApi.md#deleteJsonWebKey) | **DELETE** /keys/{set}/{kid} | Delete a JSON Web Key
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**deleteJsonWebKeySet**](docs/JsonWebKeyApi.md#deleteJsonWebKeySet) | **DELETE** /keys/{set} | Delete a JSON Web Key Set
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**getJsonWebKey**](docs/JsonWebKeyApi.md#getJsonWebKey) | **GET** /keys/{set}/{kid} | Retrieve a JSON Web Key
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**getJsonWebKeySet**](docs/JsonWebKeyApi.md#getJsonWebKeySet) | **GET** /keys/{set} | Retrieve a JSON Web Key Set
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**updateJsonWebKey**](docs/JsonWebKeyApi.md#updateJsonWebKey) | **PUT** /keys/{set}/{kid} | Update a JSON Web Key
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeyApi* | [**updateJsonWebKeySet**](docs/JsonWebKeyApi.md#updateJsonWebKeySet) | **PUT** /keys/{set} | Update a JSON Web Key Set
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.MetricsApi* | [**getPrometheusMetrics**](docs/MetricsApi.md#getPrometheusMetrics) | **GET** /metrics/prometheus | Retrieve Prometheus metrics
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**acceptConsentRequest**](docs/OAuth2Api.md#acceptConsentRequest) | **PUT** /oauth2/auth/requests/consent/{challenge}/accept | Accept an consent request
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**acceptLoginRequest**](docs/OAuth2Api.md#acceptLoginRequest) | **PUT** /oauth2/auth/requests/login/{challenge}/accept | Accept an login request
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**createOAuth2Client**](docs/OAuth2Api.md#createOAuth2Client) | **POST** /clients | Create an OAuth 2.0 client
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**deleteOAuth2Client**](docs/OAuth2Api.md#deleteOAuth2Client) | **DELETE** /clients/{id} | Deletes an OAuth 2.0 Client
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**flushInactiveOAuth2Tokens**](docs/OAuth2Api.md#flushInactiveOAuth2Tokens) | **POST** /oauth2/flush | Flush Expired OAuth2 Access Tokens
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**getConsentRequest**](docs/OAuth2Api.md#getConsentRequest) | **GET** /oauth2/auth/requests/consent/{challenge} | Get consent request information
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**getLoginRequest**](docs/OAuth2Api.md#getLoginRequest) | **GET** /oauth2/auth/requests/login/{challenge} | Get an login request
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**getOAuth2Client**](docs/OAuth2Api.md#getOAuth2Client) | **GET** /clients/{id} | Get an OAuth 2.0 Client.
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**getWellKnown**](docs/OAuth2Api.md#getWellKnown) | **GET** /.well-known/openid-configuration | Server well known configuration
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**introspectOAuth2Token**](docs/OAuth2Api.md#introspectOAuth2Token) | **POST** /oauth2/introspect | Introspect OAuth2 tokens
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**listOAuth2Clients**](docs/OAuth2Api.md#listOAuth2Clients) | **GET** /clients | List OAuth 2.0 Clients
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**oauthAuth**](docs/OAuth2Api.md#oauthAuth) | **GET** /oauth2/auth | The OAuth 2.0 authorize endpoint
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**oauthToken**](docs/OAuth2Api.md#oauthToken) | **POST** /oauth2/token | The OAuth 2.0 token endpoint
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**rejectConsentRequest**](docs/OAuth2Api.md#rejectConsentRequest) | **PUT** /oauth2/auth/requests/consent/{challenge}/reject | Reject an consent request
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**rejectLoginRequest**](docs/OAuth2Api.md#rejectLoginRequest) | **PUT** /oauth2/auth/requests/login/{challenge}/reject | Reject an logout request
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**revokeOAuth2Token**](docs/OAuth2Api.md#revokeOAuth2Token) | **POST** /oauth2/revoke | Revoke OAuth2 tokens
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**updateOAuth2Client**](docs/OAuth2Api.md#updateOAuth2Client) | **PUT** /clients/{id} | Update an OAuth 2.0 Client
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**userinfo**](docs/OAuth2Api.md#userinfo) | **POST** /userinfo | OpenID Connect Userinfo
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Api* | [**wellKnown**](docs/OAuth2Api.md#wellKnown) | **GET** /.well-known/jwks.json | Get Well-Known JSON Web Keys
*OryHydraCloudNativeOAuth20AndOpenIdConnectServer.VersionApi* | [**getVersion**](docs/VersionApi.md#getVersion) | **GET** /version | Get the version of Hydra


## Documentation for Models

 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.AcceptConsentRequest](docs/AcceptConsentRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.AcceptLoginRequest](docs/AcceptLoginRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.AuthenticationSession](docs/AuthenticationSession.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.CompletedRequest](docs/CompletedRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ConsentRequest](docs/ConsentRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ConsentRequestSession](docs/ConsentRequestSession.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.FlushInactiveOAuth2TokensRequest](docs/FlushInactiveOAuth2TokensRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Handler](docs/Handler.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.HealthNotReadyStatus](docs/HealthNotReadyStatus.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.HealthStatus](docs/HealthStatus.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.InlineResponse401](docs/InlineResponse401.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JoseWebKeySetRequest](docs/JoseWebKeySetRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKey](docs/JsonWebKey.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeySet](docs/JsonWebKeySet.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.JsonWebKeySetGeneratorRequest](docs/JsonWebKeySetGeneratorRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.KeyGenerator](docs/KeyGenerator.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.LoginRequest](docs/LoginRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Manager](docs/Manager.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2Client](docs/OAuth2Client.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OAuth2TokenIntrospection](docs/OAuth2TokenIntrospection.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OauthTokenResponse](docs/OauthTokenResponse.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.OpenIDConnectContext](docs/OpenIDConnectContext.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.RawMessage](docs/RawMessage.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.RejectRequest](docs/RejectRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerFlushInactiveAccessTokens](docs/SwaggerFlushInactiveAccessTokens.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerJsonWebKeyQuery](docs/SwaggerJsonWebKeyQuery.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerJwkCreateSet](docs/SwaggerJwkCreateSet.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerJwkSetQuery](docs/SwaggerJwkSetQuery.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerJwkUpdateSet](docs/SwaggerJwkUpdateSet.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerJwkUpdateSetKey](docs/SwaggerJwkUpdateSetKey.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerOAuthIntrospectionRequest](docs/SwaggerOAuthIntrospectionRequest.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.SwaggerRevokeOAuth2TokenParameters](docs/SwaggerRevokeOAuth2TokenParameters.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.UserinfoResponse](docs/UserinfoResponse.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Version](docs/Version.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.WellKnown](docs/WellKnown.md)
 - [OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Writer](docs/Writer.md)


## Documentation for Authorization


### basic

- **Type**: HTTP basic authentication

### oauth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://your-hydra-instance.com/oauth2/auth
- **Scopes**: 
  - offline: A scope required when requesting refresh tokens
  - openid: Request an OpenID Connect ID Token

