/**
 * ORY Hydra - Cloud Native OAuth 2.0 and OpenID Connect Server
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here. Keep in mind that this document reflects the latest branch, always. Support for versioned documentation is coming in the future.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.am
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define([
      'ApiClient',
      'model/KeyGenerator',
      'model/Manager',
      'model/Writer'
    ], factory)
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(
      require('../ApiClient'),
      require('./KeyGenerator'),
      require('./Manager'),
      require('./Writer')
    )
  } else {
    // Browser globals (root is window)
    if (!root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer) {
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer = {}
    }
    root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Handler = factory(
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.ApiClient,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.KeyGenerator,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Manager,
      root.OryHydraCloudNativeOAuth20AndOpenIdConnectServer.Writer
    )
  }
})(this, function(ApiClient, KeyGenerator, Manager, Writer) {
  'use strict'

  /**
   * The Handler model module.
   * @module model/Handler
   * @version Latest
   */

  /**
   * Constructs a new <code>Handler</code>.
   * @alias module:model/Handler
   * @class
   */
  var exports = function() {
    var _this = this
  }

  /**
   * Constructs a <code>Handler</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Handler} obj Optional instance to populate.
   * @return {module:model/Handler} The populated <code>Handler</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports()

      if (data.hasOwnProperty('Generators')) {
        obj['Generators'] = ApiClient.convertToType(data['Generators'], {
          String: KeyGenerator
        })
      }
      if (data.hasOwnProperty('H')) {
        obj['H'] = Writer.constructFromObject(data['H'])
      }
      if (data.hasOwnProperty('Manager')) {
        obj['Manager'] = Manager.constructFromObject(data['Manager'])
      }
    }
    return obj
  }

  /**
   * @member {Object.<String, module:model/KeyGenerator>} Generators
   */
  exports.prototype['Generators'] = undefined
  /**
   * @member {module:model/Writer} H
   */
  exports.prototype['H'] = undefined
  /**
   * @member {module:model/Manager} Manager
   */
  exports.prototype['Manager'] = undefined

  return exports
})
